/*
 : 	, . 
  cxema.at.ua


      

   4 
 PIC16F628A
WDT OFF
*/

#include <htc.h>
//#include <delay.h>
#define _XTAL_FREQ 4000000
__CONFIG(UNPROTECT & UNPROTECT & LVPDIS & BORDIS & MCLREN & PWRTEN & WDTDIS & INTIO);
#include <pic16f62xa.h>

#define M_inc RB4
#define M_dec RB3
#define S_inc RB2
#define S_dec RB1
#define START RB0

unsigned char buffer;
// , , 
unsigned char hours, minuts, seconds, nagruzka, buzzer;						//  
unsigned char strob;	//   
unsigned char I, II, III, IV;	// 
unsigned char kod[10] = {0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90};			// 
unsigned char r_hours, r_minuts, r_seconds;							//      

unsigned char sound;
bit razresh, tochka;
//  
//   
void reserve_copy(void)
{
r_hours = hours;
r_minuts = minuts;
r_seconds = seconds;
}
void reserve_paste(void)
{
hours = r_hours;
minuts = r_minuts;
seconds = r_seconds;
}

void decoding(void)
{
I = II = III = IV = 0;
unsigned char a, b, c, d;
a = b = c = d = 0;
if (hours == 0)
	{	
	a = minuts;
	while(a > 9)
		{
		a -= 10;
		IV++;
		}
	IV = kod[IV];
	III = kod[a];
	if(razresh == 1)
		{
		if(tochka == 1)
			{
			III -= 128;
			}
		}
	b = seconds/2;
	while(b > 9)
		{
		b -= 10;
		II++;
		}
	II = kod[II];
	I = kod[b];
	}
else
	{
	a = minuts;
	while(a > 9)
		{
		a -= 10;
		II++;
		}
	II = kod[II];
	I = kod[a];
	b = hours;
	while(b > 9)
		{
		b -= 10;
		IV++;
		}
	IV = kod[IV];
	III = kod[b];
	if(razresh == 1)
		{
		if(tochka == 1)
			{
			III -= 128;
			}
		}
	}
}


void main(void)
{
//  ,  
OPTION = 0x00;
//    ,   1  2
INTCON = 0xC0;
//  2    PR2
PIE1 = 0x03;
//    120 .    
//     1.9 
T1CON = 0xF0;
//   2 - 16. 1000000/16 = 62500 .
//     - 240  -  60   
//       .
seconds = 0;
I = kod[0];
II = kod[0];
III = kod[0];
IV = kod[0];
T2CON = 0x08;
CMCON = 0x07;
PR2 = 0x00;
TMR2 = 0x01;
//   
strob = 0x01;
//    
TRISA = 0x00;
TRISB = 0x00;
PORTA = 0x01;
PORTB = 0x00;
//  
hours = 0;
minuts = 1;
seconds = 0;
razresh = 0;
tochka = 0;
nagruzka = 0;
//   
decoding();
TMR2ON = 1;
TMR1ON = 1;

while (1) 
	{		
	}
}

interrupt void isr(void)
{
#pragma interrupt_level 1
if (TMR2IE && TMR2IF)						//  
	{
	TMR2IF = 0;
	switch(strob)
		{
		case 0x01: strob = 0x02; PORTA = (0x00 + nagruzka + buzzer); PORTB = II; PORTA = (0x02 + nagruzka + buzzer); break;
		case 0x02: strob = 0x04; PORTA = (0x00 + nagruzka + buzzer); PORTB = III; PORTA = (0x04 + nagruzka + buzzer); break;
		case 0x04: strob = 0x08; PORTA = (0x00 + nagruzka + buzzer); PORTB = IV; PORTA = (0x08 + nagruzka + buzzer); break;
		case 0x08: strob = 0x01; PORTA = (0x00 + nagruzka + buzzer); PORTB = I; PORTA = (0x01 + nagruzka + buzzer); break;
		case 0x00: strob = 0x01; PORTA = (0x00 + nagruzka + buzzer); PORTB = IV; PORTA = (0x08 + nagruzka + buzzer); break;
		}
	}
#pragma interrupt_level 0
if (TMR1IE && TMR1IF)						// 
	{
	TMR1IF = 0;
	TMR1L = 0xDC;
	TMR1H = 0x0B;
	if (razresh == 1)
		{
		seconds --;
		if(hours == 0)
		{
		if(minuts == 0)
			{
			if(seconds == 0)
				{
				razresh = 0;
				nagruzka = 0;
				reserve_paste();
				goto exit;
				}
			if(((seconds < 7) & (seconds > 1)) | ((seconds < 21) & (seconds > 19))) buzzer = 0x40;
			else buzzer = 0;
			}
		}
		if (seconds > 119) 
			{
			seconds = 119;
			minuts--;
			if (minuts > 59)
				{
				minuts = 59;
				hours--;
				if(hours > 11) hours = 11;
				}
			}
		}
	if (tochka == 1) tochka = 0;
	else tochka = 1;	
	//   
	TRISA = 0xFF;
	TRISB = 0xFF;
//    ,     2 , 
//   -       .
	if (START == 0)
		{
		if (razresh == 1) 
			{
			razresh = 0;
			buzzer = 0;
			nagruzka = 0x00;
			}
		else	
			{
			razresh = 1;
			nagruzka = 0x10;
			};
		__delay_ms(1);
		while (START == 0) {}
		};
//        
	if (razresh == 0)
		{
		unsigned char pause;
		TMR2IE = 0;
		if (M_inc == 0)
			{
			if(S_inc == 0)
				{
				hours++;
				if (hours > 11) hours = 0;
				goto exit;
				}
			minuts++;
			if (minuts > 59)
				{
				minuts = 0;
				hours++;
				if (hours > 11) hours = 0;
				}
			}
		if (M_dec == 0)
			{
			if(S_dec == 0)
				{
				hours--;
				if (hours > 11) hours = 11;
				goto exit;
				}
			minuts--;
			if (minuts > 59)
				{
				minuts = 59;
				hours--;
				if (hours > 11) hours = 11;
				}
			}
		if (S_inc == 0)
			{
			seconds += 2;
			if (seconds > 119)
				{
				seconds = 0;
				minuts++;
				if (minuts > 59)
					{
					minuts = 0;
					hours++;
					if (hours > 11) hours = 0;
					}
				}
			}
		if (S_dec == 0)
			{
			seconds -= 2;
			if (seconds > 119)
				{
				seconds = 119;
				minuts--;
				if (minuts > 59)
					{
					minuts = 59;
					hours--;
					if (hours > 11) hours = 11;
					}
				}
			}
		TMR1H = 0xB0;							//   
exit:	reserve_copy();
		TMR2IE = 1;
		}
	TRISA = 0x00;
	TRISB = 0x00;
	decoding();
	}
}